﻿local SimpleNotepad_NoteTitle
local SimpleNotepad_NoteText
local SimpleNotepad_CurrentNote
local SimpleNotepad_CurrPage
local SimpleNotepadInitCount = 1
local SimpleNotepad_PinButton


-- check for Database, if not, load the default database.

function SimpleNotepad_Initialize() 

	if (SimpleNotepadDB == nil) then
		SimpleNotepadDB = {}
	end
	if (SimpleNotepadDB.Notes == nil) then
		SimpleNotepadDB.Notes = {}
		SimpleNotepadDB.Notes = SimpleNotepad_Default_Notes
		ChatFrame1:AddMessage("SimpleNotepad Resetting Default Notes")
	end
	if (SimpleNotepadDB.Options == nil) then
		SimpleNotepadDB.Options = {}
		SimpleNotepadDB.Options = SimpleNotepad_Default_Options
		ChatFrame1:AddMessage("SimpleNotepad Resetting Default Options")
	end	
	SimpleNotepad_PinButton = SimpleNotepadDB.Options[1].SimpleNotepadPinButton
end

--  Frame On_Load/Close Button --
function SimpleNotepad_OnLoad(frame)
	frame:RegisterForDrag("LeftButton")
	frame:RegisterEvent("UNIT_COMBAT")

	frame.CloseButton = CreateFrame("Button","CloseButton",SimpleNotepadFrame,"UIPanelCloseButton")
	frame.CloseButton:SetWidth(32)
	frame.CloseButton:SetHeight(32)
	frame.CloseButton:SetPoint("TOPRIGHT", -28, -9)
	frame.CloseButton:SetScript("OnClick", function ()
	frame:Hide()
	end)

	SlashCmdList["URNOTEPAD"] = SimpleNotepad_Show
	SLASH_URNOTEPAD1 = "/snp"
	SLASH_URNOTEPAD2 = "/simplenotepad"

	frame:Hide()
end

function SimpleNotepad_Show()
	SimpleNotepadFrame:Show()
end

function SimpleNotepad_OnEvent(frame, event, ...)

	if event == "ADDON_LOADED" then
		if SimpleNotepadInitCount == 1 then
		    SimpleNotepadInitCount = SimpleNotepadInitCount + 1
		end
		    SimpleNotepad_Initialize()
		    SimpleNotepadSaveNoteButton:Show()
	end
	
	if event == "UNIT_COMBAT" then
		if SimpleNotepadFrame:IsShown() then
			SimpleNotepadFrame:Hide()
			ChatFrame1:AddMessage("SimpleNotepad has Closed - Look out behind You!",1,0,0)
		end
	end

end

-- Text Entry --
function SimpleNotepadFrameEditBox_OnSizeChanged(self)

	if self:GetHeight() > 285 then
		self:SetHeight(285)
		self:SetText(SimpleNotepad_NoteText)
	end
end

function SimpleNotepadFrameEditBox_OnChar(self, text)

	if SimpleNotepadFrameEditBox:GetHeight() <= 285 then
		SimpleNotepad_NoteText = self:GetText()
	end
end

--  Create/Cancel/Done/Yes --
function SimpleNotepadCreateNoteButton_OnClick(self)

	--delete--
	if SimpleNotepadCreateNoteButton:GetText() == "YES" then
		SimpleNotepadDeleteNoteButton_OnClick("YES","","")
	end

	--listings--
	if SimpleNotepadFrameEditBox:IsShown() then
		SimpleNotepadFrameTitleBox:Hide()
		SimpleNotepadFrameEditBox:Hide()
        SimpleNotepadCreateNoteButton:SetText("Create Note")
		SimpleNotepadSaveNoteButton:Show()
		SimpleNotepadDeleteNoteButton:Hide()
		SimpleNotepadList:Show()
		else
		SimpleNotepadList:Hide()
		SimpleNotepadFrameTitleBox:SetText("Enter Title, then press TAB.")
		SimpleNotepadFrameTitleBox:Show()
		SimpleNotepadFrameEditBox:SetText("New Note.")
		SimpleNotepadFrameEditBox:Show()
		SimpleNotepadFrameTitleBox:SetFocus()
		SimpleNotepadFrameTitleBox:HighlightText(0, 38)
		SimpleNotepadCreateNoteButton:SetText("Cancel Note")
		SimpleNotepadSaveNoteButton:SetText("Save Note")
		SimpleNotepadSaveNoteButton:Show()
		SimpleNotepadDeleteNoteButton:Hide()
		end
	end


-- Save/Update/No/Search Note Button --
function SimpleNotepadSaveNoteButton_OnClick(self)

	-- - Update --
	if SimpleNotepadSaveNoteButton:GetText() == "Update Note" then
		if #SimpleNotepadFrameTitleBox:GetText() == 0 then
			message("You must enter a Title before you can save.")
			SimpleNotepadFrameTitleBox:SetFocus()
		else
			SimpleNotepadDB.Notes[SimpleNotepad_CurrentNote].Title = SimpleNotepadFrameTitleBox:GetText()
			SimpleNotepadDB.Notes[SimpleNotepad_CurrentNote].note = SimpleNotepadFrameEditBox:GetText()
			ChatFrame1:AddMessage("Updated Note: "..SimpleNotepad_CurrentNote)
			SimpleNotepad_DisplayNotePage(SimpleNotepad_CurrPage)
		end
	end

	if SimpleNotepadSaveNoteButton:GetText() == "NO" then
		SimpleNotepadDeleteNoteButton_OnClick("NO","","")
	end
	
-- Create Note --
	if SimpleNotepadSaveNoteButton:GetText() == "Save Note" then
		local SimpleNotepadMaxTbl = #SimpleNotepadDB.Notes
		SimpleNotepadMaxTbl = SimpleNotepadMaxTbl + 1
		table.insert(SimpleNotepadDB.Notes, SimpleNotepadMaxTbl, {["Title"] = "x", ["note"] = "x",})
		SimpleNotepadDB.Notes[SimpleNotepadMaxTbl].Title = SimpleNotepadFrameTitleBox:GetText()
		SimpleNotepadDB.Notes[SimpleNotepadMaxTbl].note = SimpleNotepadFrameEditBox:GetText()
		ChatFrame1:AddMessage("Note Added.")
		SimpleNotepadSaveNoteButton:SetText("Update Note")
		SimpleNotepadCreateNoteButton:SetText("Done")
		SimpleNotepadDeleteNoteButton:Show()
		SimpleNotepadDeleteNoteButton:Enable()
		SimpleNotepad_CurrentNote = SimpleNotepadMaxTbl
		SimpleNotepad_DisplayNotePage(SimpleNotepad_CurrPage)
	end
end

-- - Delete Note --
function SimpleNotepadDeleteNoteButton_OnClick(self, button, down)
	if self == "YES" then
		table.remove(SimpleNotepadDB.Notes, SimpleNotepad_CurrentNote)
		SimpleNotepadDeleteNoteButton:Enable()
		SimpleNotepadSaveNoteButton:SetText("Update Note")
		SimpleNotepadCreateNoteButton:SetText("Done")
		SimpleNotepadDeleteConfirmation:Hide()		
		SimpleNotepad_DisplayNotePage(SimpleNotepad_CurrPage)
		ChatFrame1:AddMessage("Deleted Note: "..SimpleNotepad_CurrentNote)
	end
	if self == "NO" then
		SimpleNotepadDeleteNoteButton:Enable()
		SimpleNotepadSaveNoteButton:SetText("Update Note")
		SimpleNotepadCreateNoteButton:SetText("Done")
		SimpleNotepadDeleteConfirmation:Hide()
	end
	if button == "LeftButton" then 
		SimpleNotepadDeleteNoteButton:Disable()
		SimpleNotepadSaveNoteButton:SetText("NO")
		SimpleNotepadCreateNoteButton:SetText("YES")
		SimpleNotepadDeleteConfText:SetText("Are you sure you want to DELETE this note?")
		SimpleNotepadDeleteConfirmation:Show()
	end
end

-- Next Page --
function SimpleNotepad_NextPageButton_OnLoad(self)
	self:SetPoint("BOTTOM", -40, -10)
	self:Hide()
end

function SimpleNotepad_NextPageButton_OnClick(self, button, down)
	if SimpleNotepad_CurrPage < SimpleNotepad_TotPages then
		SimpleNotepad_CurrPage = SimpleNotepad_CurrPage + 1
	end
	SimpleNotepad_DisplayNotePage(SimpleNotepad_CurrPage)
end

--  Previous Page --
function SimpleNotepad_PreviousPageButton_OnLoad(self)
	self:SetPoint("BOTTOM", -100, -10)
	self:Hide()
end

function SimpleNotepad_PreviousPageButton_OnClick(self, button, down)
	if SimpleNotepad_CurrPage > 1 then
		SimpleNotepad_CurrPage = SimpleNotepad_CurrPage - 1
	end
	SimpleNotepad_DisplayNotePage(SimpleNotepad_CurrPage)
end


-- Note List --
function SimpleNotepad_DisplayNoteList(title)
	SimpleNotepad_Notes_List = ""
	SimpleNotepad_TotPages = 0
	SimpleNotepad_TmpPages = 0
	SimpleNotepad_Count = 0
	SimpleNotepad_CurPage = 0
	SimpleNotepad_NoteData = {}
	SimpleNotepad_NoteData = SimpleNotepadDB.Notes
	table.sort(SimpleNotepad_NoteData, SimpleNotepad_NotesListSort)

	SimpleNotepadList = {}

	for i=1, #SimpleNotepad_NoteData do
		info = {}
		
		info = SimpleNotepad_NoteData[i]			
		if tostring(info.title) == title then
				SimpleNotepad_Count = SimpleNotepad_Count + 1
				table.insert(SimpleNotepadList, SimpleNotepad_Count, i)
			end
		end
	
-- Count Pages --
	SimpleNotepad_TmpPages = (SimpleNotepad_Count / 15)
	SimpleNotepad_TotPages = math.floor(SimpleNotepad_TmpPages)
	if SimpleNotepad_TmpPages > SimpleNotepad_TotPages then
		SimpleNotepad_TotPages = SimpleNotepad_TotPages + 1
	end
	SimpleNotepad_CurrPage=1
	SimpleNotepad_DisplayNotePage(SimpleNotepad_CurrPage)
end

function SimpleNotepad_NotesListSort(a, b)
	if a.isTitle ~= 1 then
		return a.Title < b.Title
	end
end
--  Display Page --
function SimpleNotepad_DisplayNotePage(page)

	
	SimpleNotepad_Notes_List = ""
	for p = 1, page do
	    if p == page then
		for i=1, 15 do
			SimpleNotepad_Rec = ((15*p)-15)+i
			
			if SimpleNotepadList[SimpleNotepad_Rec] ~= nil then
				local SimpleNotepad_NoteTitle = ""
				local SimpleNotepad_NoteNumber = 0
				SimpleNotepad_NoteTitle = tostring(SimpleNotepadDB.Notes[SimpleNotepadList[SimpleNotepad_Rec]].Title)
				if string.len(SimpleNotepad_NoteTitle) > 27 then
					SimpleNotepad_NoteTitle = string.sub(SimpleNotepad_NoteTitle,1,27).."..."
				end

				SimpleNotepad_NoteNumber = SimpleNotepadList[SimpleNotepad_Rec]
				SimpleNotepad_Notes_List = SimpleNotepad_Notes_List .. SimpleNotepad_NoteTitle .. "\n"

				if i == 1 then 
					SimpleNotepadList.OpenNote1:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote1:Show() 
				end
				if i == 2 then 
					SimpleNotepadList.OpenNote2:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote2:Show() 
				end
				if i == 3 then 
					SimpleNotepadList.OpenNote3:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote3:Show() 
				end
				if i == 4 then 
					SimpleNotepadList.OpenNote4:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote4:Show() 
				end
				if i == 5 then 
					SimpleNotepadList.OpenNote5:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote5:Show() 
				end
				if i == 6 then 
					SimpleNotepadList.OpenNote6:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote6:Show() 
				end
				if i == 7 then 
					SimpleNotepadList.OpenNote7:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote7:Show() 
				end
				if i == 8 then 
					SimpleNotepadList.OpenNote8:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote8:Show() 
				end
				if i == 9 then 
					SimpleNotepadList.OpenNote9:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote9:Show() 
				end
				if i == 10 then 
					SimpleNotepadList.OpenNote10:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote10:Show() 
				end
				if i == 11 then 
					SimpleNotepadList.OpenNote11:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote11:Show() 
				end
				if i == 12 then 
					SimpleNotepadList.OpenNote12:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote12:Show() 
				end
				if i == 13 then 
					SimpleNotepadList.OpenNote13:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote13:Show() 
				end
				if i == 14 then 
					SimpleNotepadList.OpenNote14:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote14:Show() 
				end
				if i == 15 then 
					SimpleNotepadList.OpenNote15:SetScript("OnClick", function ()
						SimpleNotepad_ShowNote(SimpleNotepad_NoteNumber)
					end)
					SimpleNotepadList.OpenNote15:Show() 
				end
			else
				if i == 1 then SimpleNotepadList.OpenNote1:Hide() end
				if i == 2 then SimpleNotepadList.OpenNote2:Hide() end
				if i == 3 then SimpleNotepadList.OpenNote3:Hide() end
				if i == 4 then SimpleNotepadList.OpenNote4:Hide() end
				if i == 5 then SimpleNotepadList.OpenNote5:Hide() end
				if i == 6 then SimpleNotepadList.OpenNote6:Hide() end
				if i == 7 then SimpleNotepadList.OpenNote7:Hide() end
				if i == 8 then SimpleNotepadList.OpenNote8:Hide() end
				if i == 9 then SimpleNotepadList.OpenNote9:Hide() end
				if i == 10 then SimpleNotepadList.OpenNote10:Hide() end
				if i == 11 then SimpleNotepadList.OpenNote11:Hide() end
				if i == 12 then SimpleNotepadList.OpenNote12:Hide() end
				if i == 13 then SimpleNotepadList.OpenNote13:Hide() end
				if i == 14 then SimpleNotepadList.OpenNote14:Hide() end
				if i == 15 then SimpleNotepadList.OpenNote15:Hide() end
			end
			
		end
		
		SimpleNotepadFrameList:SetText(SimpleNotepad_Notes_List .. tostring(SimpleNotepad_Count) .. " Total Notes. - " .. SimpleNotepad_TotPages .. " Pages.")
	   end
	end

	SimpleNotepad_NextPageButton:Hide()
	SimpleNotepad_PreviousPageButton:Hide()

	if SimpleNotepad_TotPages > 1 then
		SimpleNotepad_NextPageButton:Show()
		SimpleNotepad_PreviousPageButton:Show()

		if SimpleNotepad_CurrPage == 1 then
			SimpleNotepad_NextPageButton:Enable()
			SimpleNotepad_PreviousPageButton:Disable()

		elseif SimpleNotepad_CurrPage == SimpleNotepad_TotPages then
			SimpleNotepad_NextPageButton:Disable()
			SimpleNotepad_PreviousPageButton:Enable()
	
		else
			SimpleNotepad_NextPageButton:Enable()
			SimpleNotepad_PreviousPageButton:Enable()
		end
	end



end

-- Show Note --
function SimpleNotepad_ShowNote(note)

	SimpleNotepad_CurrentNote = note
	SimpleNotepad_NoteText = SimpleNotepadDB.Notes[note].note
	SimpleNotepad_NoteTitle = SimpleNotepadDB.Notes[note].Title
	SimpleNotepadFrameEditBox:SetText(SimpleNotepad_NoteText)
	SimpleNotepadFrameTitleBox:SetText(SimpleNotepad_NoteTitle)

	SimpleNotepadList:Hide()

	SimpleNotepadFrameTitleBox:Show()
	SimpleNotepadFrameEditBox:Show()
	SimpleNotepadFrameEditBox:SetFocus()
	SimpleNotepadCreateNoteButton:SetText("Done")
	SimpleNotepadCreateNoteButton:Enable()
	SimpleNotepadCreateNoteButton:Show()
	SimpleNotepadSaveNoteButton:SetText("Update Note")
	SimpleNotepadSaveNoteButton:Show()
	SimpleNotepadDeleteNoteButton:Show()
	SimpleNotepadDeleteNoteButton:Enable()
    SimpleNotepadSaveNoteButton:Enable()
	SimpleNotepadDeleteNoteButton:Enable()
	SimpleNotepadDeleteConfirmation:Hide()

-- Count Note Pages --
	SimpleNotepad_TmpPages = (SimpleNotepad_Count / 15)
	SimpleNotepad_TotPages = math.floor(SimpleNotepad_TmpPages)
	if SimpleNotepad_TmpPages > SimpleNotepad_TotPages then
		SimpleNotepad_TotPages = SimpleNotepad_TotPages + 1
	end
	SimpleNotepad_CurrPage=1

	if SimpleNotepad_Count > 0 then	
		SimpleNotepadList:Show()
		SimpleNotepadFrameTitleBox:Hide()
		SimpleNotepadSearchFrame:Hide()
		SimpleNotepadDeleteConfirmation:Hide()
		SimpleNotepadCreateNoteButton:Disable()
		SimpleNotepad_DisplayNotePage(SimpleNotepad_CurrPage)
	else
		SimpleNotepadDeleteConfText:SetText("Search String not Found!!!!")
		SimpleNotepadDeleteConfirmation:Show()
	end
end

-- Hide Buttons --
function SimpleNotepad_HideAllButtons()
	SimpleNotepadList.OpenNote1:Hide()
	SimpleNotepadList.OpenNote2:Hide()
	SimpleNotepadList.OpenNote3:Hide()
	SimpleNotepadList.OpenNote4:Hide()
	SimpleNotepadList.OpenNote5:Hide()
	SimpleNotepadList.OpenNote6:Hide()
	SimpleNotepadList.OpenNote7:Hide()
	SimpleNotepadList.OpenNote8:Hide()
	SimpleNotepadList.OpenNote9:Hide()
	SimpleNotepadList.OpenNote10:Hide()
	SimpleNotepadList.OpenNote11:Hide()
	SimpleNotepadList.OpenNote12:Hide()
	SimpleNotepadList.OpenNote13:Hide()
	SimpleNotepadList.OpenNote14:Hide()
	SimpleNotepadList.OpenNote15:Hide()
end



-- Pin --
function SimpleNotepadOptionsFramePinButton_OnLoad(self)
	SimpleNotepadOptionsFramePinButton:SetChecked(SimpleNotepad_PinButton)
end

function SimpleNotepadOptionsFramePinButton_OnClick(self)
	if self:GetChecked() == nil then
		SimpleNotepad_PinButton = 0
	else
		SimpleNotepad_PinButton = 1
	end 
	SimpleNotepadDB.Options[1].SimpleNotepadPinButton = SimpleNotepad_PinButton
end

local LibQTip = LibStub:GetLibrary("LibQTip-1.0")  --Loaded to Enable LDB dislpay--
local LibQTip = LibStub:GetLibrary("LibAboutPanel") -- TOC about panel --
    
       
    
--LDB supported Minimap Button--
            
    local SimpleNotepadLDB = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("SimpleNotepad", {
        type = "launcher",
	    text = "SimpleNotepad",
        tocname = "SimpleNotepad",
        icon = "Interface\\AddOns\\SimpleNotepad\\img\\NotePadL",
        OnClick = function(self, button)
        if button == "LeftButton" then
		if SimpleNotepadFrame:IsShown() then
		    SimpleNotepadFrame:Hide()
		else
		    SimpleNotepadFrame:Hide()
			SimpleNotepadFrame:Show()
		end
	    elseif (button == "RightButton") then
		    InterfaceOptionsFrame_OpenToCategory("SimpleNotepad") 
         end
      end,
        OnTooltipShow = function(tooltip)
            tooltip:AddLine('SimpleNotepad')
            tooltip:AddLine('|cffffff00Left click for SimpleNotepad')
            tooltip:AddLine('|cffffff00Right Click for SimpleNotepad Options')
        end,
})

        local icon = LibStub("LibDBIcon-1.0")
        icon:Register("SimpleNotepad", SimpleNotepadLDB, SimpleNotepadDB.minimap)  
       
        
        
        
        
        if (LibStub:GetLibrary("LibAboutPanel", true)) then
	    LibStub("LibAboutPanel").new("SimpleNotepad", "SimpleNotepad")
    else
		self:Print("Lib AboutPanel not loaded.")
    end
        
  